Index: asp3_wo_tecs/trunk/extension/subprio/kernel/sys_manage.c
===================================================================
--- asp3_wo_tecs/trunk/extension/subprio/kernel/sys_manage.c	(revision 305)
+++ asp3_wo_tecs/trunk/extension/subprio/kernel/sys_manage.c	(revision 306)
@@ -53,5 +53,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: sys_manage.c 470 2015-12-30 09:50:36Z ertl-hiro $
+ *  $Id: sys_manage.c 684 2016-03-11 15:24:12Z ertl-hiro $
  */
 
@@ -174,5 +174,5 @@
 /*
  *  ã¿ã¹ã¯ã®åªå
-é ä½ã®åè»¢
+é ä½ã®åè»¢ï¼»NGKI3548ï¼½
  */
 #ifdef TOPPERS_rot_rdq
@@ -185,10 +185,10 @@
 
 	LOG_ROT_RDQ_ENTER(tskpri);
-	CHECK_UNL();
+	CHECK_UNL();								/*ï¼»NGKI2684ï¼½*/
 	if (tskpri == TPRI_SELF && !sense_context()) {
-		pri = p_runtsk->bpriority;
+		pri = p_runtsk->bpriority;				/*ï¼»NGKI2689ï¼½*/
 	}
 	else {
-		CHECK_PAR(VALID_TPRI(tskpri));
+		CHECK_PAR(VALID_TPRI(tskpri));			/*ï¼»NGKI2685ï¼½*/
 		pri = INT_PRIORITY(tskpri);
 	}
@@ -218,5 +218,5 @@
  *  å®è¡ç¶æ
 ã®ã¿ã¹ã¯IDã®åç
-§
+§ï¼»NGKI3550ï¼½
  */
 #ifdef TOPPERS_get_tid
@@ -228,5 +228,5 @@
 
 	LOG_GET_TID_ENTER(p_tskid);
-	CHECK_UNL();
+	CHECK_UNL();								/*ï¼»NGKI2707ï¼½*/
 
 	lock_cpu();
@@ -244,5 +244,5 @@
 /*
  *  å®è¡ã§ããã¿ã¹ã¯ã®æ°ã®åç
-§
+§ï¼»NGKI3623ï¼½
  */
 #ifdef TOPPERS_get_lod
@@ -256,10 +256,10 @@
 
 	LOG_GET_LOD_ENTER(p_tskid, p_load);
-	CHECK_TSKCTX_UNL();
+	CHECK_TSKCTX_UNL();							/*ï¼»NGKI3624ï¼½ï¼»NGKI3625ï¼½*/
 	if (tskpri == TPRI_SELF) {
-		pri = p_runtsk->bpriority;
+		pri = p_runtsk->bpriority;				/*ï¼»NGKI3631ï¼½*/
 	}
 	else {
-		CHECK_PAR(VALID_TPRI(tskpri));
+		CHECK_PAR(VALID_TPRI(tskpri));			/*ï¼»NGKI3626ï¼½*/
 		pri = INT_PRIORITY(tskpri);
 	}
@@ -286,5 +286,5 @@
  *  æå®ããåªå
 é ä½ã®ã¿ã¹ã¯IDã®åç
-§
+§ï¼»NGKI3641ï¼½
  */
 #ifdef TOPPERS_get_nth
@@ -299,10 +299,10 @@
 
 	LOG_GET_NTH_ENTER(p_tskid, nth, p_tskid);
-	CHECK_TSKCTX_UNL();
+	CHECK_TSKCTX_UNL();							/*ï¼»NGKI3642ï¼½ï¼»NGKI3643ï¼½*/
 	if (tskpri == TPRI_SELF) {
-		pri = p_runtsk->bpriority;
+		pri = p_runtsk->bpriority;				/*ï¼»NGKI3650ï¼½*/
 	}
 	else {
-		CHECK_PAR(VALID_TPRI(tskpri));
+		CHECK_PAR(VALID_TPRI(tskpri));			/*ï¼»NGKI3644ï¼½*/
 		pri = INT_PRIORITY(tskpri);
 	}
@@ -332,5 +332,5 @@
 /*
  *  CPUã­ãã¯ç¶æ
-ã¸ã®é·ç§»
+ã¸ã®é·ç§»ï¼»NGKI3538ï¼½
  */
 #ifdef TOPPERS_loc_cpu
@@ -343,6 +343,6 @@
 	LOG_LOC_CPU_ENTER();
 
-	if (!sense_lock()) {
-		lock_cpu();
+	if (!sense_lock()) {						/*ï¼»NGKI2731ï¼½*/
+		lock_cpu();								/*ï¼»NGKI2730ï¼½*/
 	}
 	ercd = E_OK;
@@ -356,5 +356,5 @@
 /*
  *  CPUã­ãã¯ç¶æ
-ã®è§£é¤
+ã®è§£é¤ï¼»NGKI3539ï¼½
  *
  *  CPUã­ãã¯ä¸­ã¯ï¼ãã£ã¹ããããå¿
@@ -374,6 +374,6 @@
 	LOG_UNL_CPU_ENTER();
 
-	if (sense_lock()) {
-		unlock_cpu();
+	if (sense_lock()) {							/*ï¼»NGKI2738ï¼½*/
+		unlock_cpu();							/*ï¼»NGKI2737ï¼½*/
 	}
 	ercd = E_OK;
@@ -386,5 +386,5 @@
 
 /*
- *  ãã£ã¹ãããã®ç¦æ­¢
+ *  ãã£ã¹ãããã®ç¦æ­¢ï¼»NGKI2740ï¼½
  */
 #ifdef TOPPERS_dis_dsp
@@ -396,5 +396,5 @@
 
 	LOG_DIS_DSP_ENTER();
-	CHECK_TSKCTX_UNL();
+	CHECK_TSKCTX_UNL();							/*ï¼»NGKI2741ï¼½ï¼»NGKI2742ï¼½*/
 
 	lock_cpu();
@@ -412,5 +412,5 @@
 
 /*
- *  ãã£ã¹ãããã®è¨±å¯
+ *  ãã£ã¹ãããã®è¨±å¯ï¼»NGKI2746ï¼½
  */
 #ifdef TOPPERS_ena_dsp
@@ -422,5 +422,5 @@
 
 	LOG_ENA_DSP_ENTER();
-	CHECK_TSKCTX_UNL();
+	CHECK_TSKCTX_UNL();							/*ï¼»NGKI2747ï¼½ï¼»NGKI2748ï¼½*/
 
 	lock_cpu();
@@ -455,5 +455,5 @@
 /*
  *  ã³ã³ãã­ã¹ãã®åç
-§
+§ï¼»NGKI2752ï¼½
  */
 #ifdef TOPPERS_sns_ctx
@@ -475,5 +475,5 @@
  *  CPUã­ãã¯ç¶æ
 ã®åç
-§
+§ï¼»NGKI2754ï¼½
  */
 #ifdef TOPPERS_sns_loc
@@ -495,5 +495,5 @@
  *  ãã£ã¹ãããç¦æ­¢ç¶æ
 ã®åç
-§
+§ï¼»NGKI2756ï¼½
  */
 #ifdef TOPPERS_sns_dsp
@@ -515,5 +515,5 @@
  *  ãã£ã¹ãããä¿çç¶æ
 ã®åç
-§
+§ï¼»NGKI2758ï¼½
  */
 #ifdef TOPPERS_sns_dpn
@@ -535,5 +535,5 @@
  *  ã«ã¼ãã«éåä½ç¶æ
 ã®åç
-§
+§ï¼»NGKI2760ï¼½
  */
 #ifdef TOPPERS_sns_ker
Index: asp3_wo_tecs/trunk/extension/subprio/kernel/task.trb
===================================================================
--- asp3_wo_tecs/trunk/extension/subprio/kernel/task.trb	(revision 306)
+++ asp3_wo_tecs/trunk/extension/subprio/kernel/task.trb	(revision 306)
@@ -0,0 +1,174 @@
+# -*- coding: utf-8 -*-
+#
+#   TOPPERS/ASP Kernel
+#       Toyohashi Open Platform for Embedded Real-Time Systems/
+#       Advanced Standard Profile Kernel
+# 
+#   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
+#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#               Graduate School of Information Science, Nagoya Univ., JAPAN
+# 
+#   ä¸è¨èä½æ¨©è
+ã¯ï¼ä»¥ä¸ã®(1)ã(4)ã®æ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§
+#   ã¢ï¼æ¬ã½ããã¦ã§ã¢ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹
+#   å¤ã»åé
+å¸ï¼ä»¥ä¸ï¼å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
+#   (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
+#       æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
+#       ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
+#   (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+#       ç¨ã§ããå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
+#       è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
+#       ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+#   (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+#       ç¨ã§ããªãå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼æ¬¡ã®ããããã®æ¡ä»¶ãæºããã
+#       ã¨ï¼
+#     (a) åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
+#         ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+#     (b) åé
+å¸ã®å½¢æ
+ãï¼å¥ã«å®ããæ¹æ³ã«ãã£ã¦ï¼TOPPERSãã­ã¸ã§ã¯ãã«
+#         å ±åãããã¨ï¼
+#   (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
+#       å®³ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ããå
+è²¬ãããã¨ï¼
+#       ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®ã¦ã¼ã¶ã¾ãã¯ã¨ã³ãã¦ã¼ã¶ããã®ãããªãç
+#       ç±ã«åºã¥ãè«æ±ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ãã
+#       å
+è²¬ãããã¨ï¼
+# 
+#   æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
+ã
+#   ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ç¹å®ã®ä½¿ç¨ç®ç
+#   ã«å¯¾ããé©åæ§ãå«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§
+#   ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ã
+#   ã®è²¬ä»»ãè² ããªãï¼
+# 
+#   $Id: task.trb 668 2016-03-03 13:57:53Z ertl-hiro $
+# 
+
+#
+#		ã¿ã¹ã¯ç®¡çã¢ã¸ã¥ã¼ã«ã®çæã¹ã¯ãªãã
+#
+
+class TaskObject < KernelObject
+  def initialize()
+    super("tsk", "task", "t")
+  end
+
+  def prepare(key, params)
+    # ãã©ã¡ã¼ã¿ãçç¥ãããæã®ããã©ã«ãå¤ã®è¨­å®
+    params[:stk] ||= "NULL"
+
+    # tskatrãç¡å¹ã®å ´åï¼E_RSATRï¼ï¼»NGKI1028ï¼½
+    #ï¼TA_ACTï¼TA_NOACTQUEï¼TARGET_TSKATRä»¥å¤ã®ããããã»ããããã¦ããå ´åï¼
+    if (params[:tskatr] & ~($TA_ACT|$TA_NOACTQUE|$TARGET_TSKATR)) != 0
+      error_illegal_id("E_RSATR", params, :tskatr, :tskid)
+    end
+
+    # (TMIN_TPRI <= itskpri && itskpri <= TMAX_TPRI)ã§ãªãå ´åï¼»NGKI1034ï¼½
+    if !($TMIN_TPRI <= params[:itskpri] && params[:itskpri] <= $TMAX_TPRI)
+      error_illegal_id("E_PAR", params, :itskpri, :tskid)
+    end
+
+    # stkszãã¿ã¼ã²ããå®ç¾©ã®æå°å¤ï¼TARGET_MIN_STKSZï¼æªå®ç¾©ã®å ´åã¯1ï¼
+    # ãããå°ããå ´åï¼»NGKI1042ï¼½
+    if params[:stksz] < $TARGET_MIN_STKSZ
+      error_wrong_id("E_PAR", params, :stksz, :tskid, "too small")
+    end
+
+    # ã¹ã¿ãã¯é åã®è¨­å®ï¼»NGKI1041ï¼½
+    if params[:stk] == "NULL"
+      # ã¹ã¿ãã¯é åã®çæï¼»NGKI1049ï¼½
+      stkName = "_kernel_stack_#{params[:tskid]}"
+      params[:tinib_stksz] = AllocStack(stkName, params[:stksz])
+      params[:tinib_stk] = stkName
+    else
+      # stkszãã¹ã¿ãã¯é åã®ãµã¤ãºã¨ãã¦æ­£ãããªãå ´åï¼»NGKI1056ï¼½
+      if (params[:stksz] & ($CHECK_STKSZ_ALIGN - 1)) != 0
+        error_wrong_id("E_PAR", params, :stksz, :tskid, "not aligned")
+      end
+
+      params[:tinib_stksz] = params[:stksz]
+      params[:tinib_stk] = "(void *)(#{params[:stk]})"
+    end
+  end
+
+  def generateInib(key, params)
+    if $USE_TSKINICTXB
+      tskinictxb = GenerateTskinictxb(key, params)
+    else
+      tskinictxb = "#{params[:tinib_stksz]}, #{params[:tinib_stk]}"
+    end
+    return("(#{params[:tskatr]}), (intptr_t)(#{params[:exinf]}), " \
+			"(TASK)(#{params[:task]}), INT_PRIORITY(#{params[:itskpri]}), " \
+			+ tskinictxb)
+  end
+end
+
+#
+#  ã¿ã¹ã¯ç®¡çã«é¢ããæ
+å ±ã®çæ
+#
+$kernelCfgC.comment_header("Task Management Functions")
+if $cfgData[:CRE_TSK].size() == 0
+  error("no task is registered")
+end
+TaskObject.new.generate()
+
+# ã¿ã¹ã¯çæé åºãã¼ãã«ã®çæ
+$kernelCfgC.add("const ID _kernel_torder_table[TNUM_TSKID] = { ")
+$kernelCfgC.append("\t")
+$cfgData[:CRE_TSK].each_with_index do |(key, params), index|
+  $kernelCfgC.append(", ") if index > 0
+  $kernelCfgC.append("#{params[:tskid]}")
+end
+$kernelCfgC.add
+$kernelCfgC.add2("};")
+
+#
+#  ENA_SPRã®å¦ç
+#
+# ã¨ã©ã¼ãã§ãã¯
+$subprioTskpri = {}
+$cfgData[:ENA_SPR].each do |key, params|
+  tskpriVal = params[:tskpri].val
+
+  #	(TMIN_TPRI <= tskpri && tskpri <= TMAX_TPRI)ã§ãªãå ´åï¼»NGKI3678ï¼½
+  if !($TMIN_TPRI <= tskpriVal && tskpriVal <= $TMAX_TPRI)
+    error_illegal("E_PAR", params, :tskpri)
+  end
+
+  if !$subprioTskpri.has_key?(tskpriVal)
+    $subprioTskpri[tskpriVal] = params[:tskpri]
+  else
+    # tskpriValããµãåªå
+åº¦ãä½¿ç¨ããåªå
+åº¦ã«è¨­å®æ¸ã¿ã®å ´å
+    warning_api(params, "tskpri `#{params[:tskpri]}' in ENA_SPR" \
+								" is same with #{$subprioTskpri[tskpriVal]}")
+  end
+end
+
+# ãµãåªå
+åº¦ãç¨ãã¦ã¹ã±ã¸ã¥ã¼ã«ããåªå
+åº¦ã®ãããããã
+$kernelCfgC.append("const uint16_t _kernel_subprio_primap = ")
+if $subprioTskpri.size > 0
+  $kernelCfgC.append("(")
+  $subprioTskpri.each_with_index do |(tskpriVal, tskpri), index|
+    $kernelCfgC.append(" | ") if index > 0
+    $kernelCfgC.append("PRIMAP_BIT(INT_PRIORITY(#{tskpri}))")
+  end
+  $kernelCfgC.add2(");")
+else
+  $kernelCfgC.add2("0U;")
+end
Index: asp3_wo_tecs/trunk/extension/subprio/test/test_subprio1.cfg
===================================================================
--- asp3_wo_tecs/trunk/extension/subprio/test/test_subprio1.cfg	(revision 305)
+++ asp3_wo_tecs/trunk/extension/subprio/test/test_subprio1.cfg	(revision 306)
@@ -3,10 +3,7 @@
 åº¦æ©è½ã®ãã¹ã(1)ã®ã·ã¹ãã ã³ã³ãã£ã®ã¥ã¬ã¼ã·ã§ã³ãã¡ã¤ã«
  *
- *  $Id: test_subprio1.cfg 260 2014-10-05 02:33:43Z ertl-hiro $
+ *  $Id: test_subprio1.cfg 572 2016-02-01 14:40:09Z ertl-hiro $
  */
-INCLUDE("target_timer.cfg");
-INCLUDE("syssvc/syslog.cfg");
-INCLUDE("syssvc/banner.cfg");
-INCLUDE("syssvc/serial.cfg");
+INCLUDE("tecsgen.cfg");
 
 #include "test_subprio1.h"
Index: asp3_wo_tecs/trunk/extension/subprio/test/test_subprio2.c
===================================================================
--- asp3_wo_tecs/trunk/extension/subprio/test/test_subprio2.c	(revision 305)
+++ asp3_wo_tecs/trunk/extension/subprio/test/test_subprio2.c	(revision 306)
@@ -3,5 +3,5 @@
  *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
- *  Copyright (C) 2014-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2014-2016 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -50,5 +50,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: test_subprio2.c 310 2015-02-08 13:46:46Z ertl-hiro $
+ *  $Id: test_subprio2.c 738 2016-04-05 14:19:24Z ertl-hiro $
  */
 
@@ -126,5 +126,5 @@
  *		chg_spr(TASK2, 10) -> E_CTX					... (B-2)
  *		unl_cpu()
- *		sta_alm(ALM1, 10000U)
+ *		sta_alm(ALM1, TEST_TIME_CP) ... ALM1-1ãå®è¡éå§ããã¾ã§
  *		slp_tsk()
  *	== TASK4ï¼ç¶ãï¼==
@@ -214,5 +214,5 @@
 	check_ercd(ercd, E_OK);
 
-	ercd = sta_alm(ALM1, 10000U);
+	ercd = sta_alm(ALM1, TEST_TIME_CP);
 	check_ercd(ercd, E_OK);
 
Index: asp3_wo_tecs/trunk/extension/subprio/test/test_subprio2.cfg
===================================================================
--- asp3_wo_tecs/trunk/extension/subprio/test/test_subprio2.cfg	(revision 305)
+++ asp3_wo_tecs/trunk/extension/subprio/test/test_subprio2.cfg	(revision 306)
@@ -3,10 +3,7 @@
 åº¦æ©è½ã®ãã¹ã(2)ã®ã·ã¹ãã ã³ã³ãã£ã®ã¥ã¬ã¼ã·ã§ã³ãã¡ã¤ã«
  *
- *  $Id: test_subprio2.cfg 327 2015-06-21 06:42:01Z ertl-hiro $
+ *  $Id: test_subprio2.cfg 572 2016-02-01 14:40:09Z ertl-hiro $
  */
-INCLUDE("target_timer.cfg");
-INCLUDE("syssvc/syslog.cfg");
-INCLUDE("syssvc/banner.cfg");
-INCLUDE("syssvc/serial.cfg");
+INCLUDE("tecsgen.cfg");
 
 #include "test_subprio2.h"
Index: asp3_wo_tecs/trunk/extension/subprio/test/test_subprio2.h
===================================================================
--- asp3_wo_tecs/trunk/extension/subprio/test/test_subprio2.h	(revision 305)
+++ asp3_wo_tecs/trunk/extension/subprio/test/test_subprio2.h	(revision 306)
@@ -3,5 +3,5 @@
  *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
- *  Copyright (C) 2014 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2014-2016 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -50,5 +50,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: test_subprio2.h 258 2014-10-04 19:37:38Z ertl-hiro $
+ *  $Id: test_subprio2.h 737 2016-04-05 13:11:23Z ertl-hiro $
  */
 
@@ -81,4 +81,13 @@
 #endif /* STACK_SIZE */
 
+#ifndef TEST_TIME_CP
+#define TEST_TIME_CP	50000U		/* ãã§ãã¯ãã¤ã³ãå°éæ
+å ±ã®åºåæé */
+#endif /* TEST_TIME_CP */
+
+#ifndef TEST_TIME_PROC
+#define TEST_TIME_PROC	1000U		/* ãã§ãã¯ãã¤ã³ããéããªãå ´åã®æé */
+#endif /* TEST_TIME_PROC */
+
 /*
  *  é¢æ°ã®ãã­ãã¿ã¤ãå®£è¨
Index: asp3_wo_tecs/trunk/include/kernel.h
===================================================================
--- asp3_wo_tecs/trunk/include/kernel.h	(revision 305)
+++ asp3_wo_tecs/trunk/include/kernel.h	(revision 306)
@@ -53,5 +53,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: kernel.h 520 2016-01-14 05:06:26Z ertl-hiro $
+ *  $Id: kernel.h 654 2016-02-20 12:59:31Z ertl-hiro $
  */
 
@@ -547,6 +547,6 @@
 #define TKERNEL_MAKER	UINT_C(0x0118)	/* ã«ã¼ãã«ã®ã¡ã¼ã«ã¼ã³ã¼ã */
 #define TKERNEL_PRID	UINT_C(0x0007)	/* ã«ã¼ãã«ã®è­å¥çªå· */
-#define TKERNEL_SPVER	UINT_C(0xf630)	/* ã«ã¼ãã«ä»æ§ã®ãã¼ã¸ã§ã³çªå· */
-#define TKERNEL_PRVER	UINT_C(0x3000)	/* ã«ã¼ãã«ã®ãã¼ã¸ã§ã³çªå· */
+#define TKERNEL_SPVER	UINT_C(0xf631)	/* ã«ã¼ãã«ä»æ§ã®ãã¼ã¸ã§ã³çªå· */
+#define TKERNEL_PRVER	UINT_C(0x3010)	/* ã«ã¼ãã«ã®ãã¼ã¸ã§ã³çªå· */
 
 /*
Index: asp3_wo_tecs/trunk/kernel/dataqueue.trb
===================================================================
--- asp3_wo_tecs/trunk/kernel/dataqueue.trb	(revision 305)
+++ asp3_wo_tecs/trunk/kernel/dataqueue.trb	(revision 306)
@@ -53,5 +53,5 @@
 #   ã®è²¬ä»»ãè² ããªãï¼
 # 
-#   $Id: dataqueue.trb 588 2016-02-05 12:54:58Z ertl-hiro $
+#   $Id: dataqueue.trb 668 2016-03-03 13:57:53Z ertl-hiro $
 # 
 
@@ -66,4 +66,7 @@
 
   def prepare(key, params)
+    # ãã©ã¡ã¼ã¿ãçç¥ãããæã®ããã©ã«ãå¤ã®è¨­å®
+    params[:dtqmb] ||= "NULL"
+
     # dtqatrãç¡å¹ã®å ´åï¼E_RSATRï¼ï¼»NGKI1669ï¼½
     #ï¼TA_TPRIä»¥å¤ã®ããããã»ããããã¦ããå ´åï¼
@@ -74,21 +77,20 @@
     # dtqmbãNULLã§ãªãå ´åï¼E_NOSPTï¼ï¼»ASPS0132ï¼½
     if params[:dtqmb] != "NULL"
-      error_illegal_id("E_PAR", params, :dtqmb, :dtqid)
+      error_illegal_id("E_NOSPT", params, :dtqmb, :dtqid)
     end
 
     # ãã¼ã¿ã­ã¥ã¼ç®¡çé å
     if params[:dtqcnt] > 0
-      $kernelCfgC.add("static DTQMB _kernel_dtqmb_#{params[:dtqid]}" \
-												"[#{params[:dtqcnt]}];")
+      dtqmbName = "_kernel_dtqmb_#{params[:dtqid]}"
+      $kernelCfgC.add("static DTQMB #{dtqmbName}[#{params[:dtqcnt]}];")
+      params[:dtqinib_dtqmb] = dtqmbName
+    else
+      params[:dtqinib_dtqmb] = "NULL"
     end
   end
 
   def generateInib(key, params)
-    if params[:dtqcnt] > 0
-      dtqmb = "_kernel_dtqmb_#{params[:dtqid]}"
-    else
-      dtqmb = "NULL"
-    end
-    return("(#{params[:dtqatr]}), (#{params[:dtqcnt]}), #{dtqmb}")
+    return("(#{params[:dtqatr]}), (#{params[:dtqcnt]}), " \
+										"#{params[:dtqinib_dtqmb]}")
   end
 end
Index: asp3_wo_tecs/trunk/kernel/exception.trb
===================================================================
--- asp3_wo_tecs/trunk/kernel/exception.trb	(revision 305)
+++ asp3_wo_tecs/trunk/kernel/exception.trb	(revision 306)
@@ -53,5 +53,5 @@
 #   ã®è²¬ä»»ãè² ããªãï¼
 # 
-#   $Id: exception.trb 588 2016-02-05 12:54:58Z ertl-hiro $
+#   $Id: exception.trb 663 2016-02-27 04:45:50Z ertl-hiro $
 # 
 
@@ -76,5 +76,5 @@
   # excatrãç¡å¹ã®å ´åï¼E_RSATRï¼ï¼»NGKI3131ï¼½
   #ï¼TARGET_EXCATRä»¥å¤ã®ããããã»ããããã¦ããå ´åï¼
-  if (params[:excatr] & ~$TARGET_EXCATR) != 0
+  if (params[:excatr] & ~($TARGET_EXCATR)) != 0
     error_illegal_sym("E_RSATR", params, :excatr, :excno)
   end
@@ -85,12 +85,11 @@
 å ±ã®çæ
 #
-if $OMIT_INITIALIZE_EXCEPTION.nil?
+if !$OMIT_INITIALIZE_EXCEPTION
   #
   #  å®ç¾©ããCPUä¾å¤ãã³ãã©ã®æ°
   #
-  $kernelCfgC.append(<<EOS)
+  $kernelCfgC.add(<<EOS)
 #define TNUM_DEF_EXCNO	#{$cfgData[:DEF_EXC].size}
 const uint_t _kernel_tnum_def_excno = TNUM_DEF_EXCNO;
-
 EOS
 
Index: asp3_wo_tecs/trunk/kernel/genoffset.trb
===================================================================
--- asp3_wo_tecs/trunk/kernel/genoffset.trb	(revision 305)
+++ asp3_wo_tecs/trunk/kernel/genoffset.trb	(revision 306)
@@ -52,5 +52,5 @@
 #   ã®è²¬ä»»ãè² ããªãï¼
 # 
-#   $Id: genoffset.trb 572 2016-02-01 14:40:09Z ertl-hiro $
+#   $Id: genoffset.trb 662 2016-02-27 02:33:51Z ertl-hiro $
 # 
 
@@ -75,5 +75,5 @@
 # 
 def GenerateDefine(symbol, value)
-  $offsetH.add("#define #{symbol}\t#{value.val}")
+  $offsetH.add("#define #{symbol}\t#{value}")
 end
 
Index: asp3_wo_tecs/trunk/kernel/interrupt.trb
===================================================================
--- asp3_wo_tecs/trunk/kernel/interrupt.trb	(revision 305)
+++ asp3_wo_tecs/trunk/kernel/interrupt.trb	(revision 306)
@@ -53,5 +53,5 @@
 #   ã®è²¬ä»»ãè² ããªãï¼
 # 
-#   $Id: interrupt.trb 612 2016-02-08 04:27:57Z ertl-hiro $
+#   $Id: interrupt.trb 678 2016-03-06 02:36:09Z ertl-hiro $
 # 
 
@@ -78,5 +78,5 @@
 #  ãã¬ã¼ã¹ã­ã°ãã¯ã­ã®ããã©ã«ãå®ç¾©
 #
-$kernelCfgC.append(<<EOS)
+$kernelCfgC.add(<<EOS)
 #ifndef LOG_ISR_ENTER
 #define LOG_ISR_ENTER(isrid)
@@ -86,5 +86,4 @@
 #define LOG_ISR_LEAVE(isrid)
 #endif /* LOG_ISR_LEAVE */
-
 EOS
 
@@ -105,5 +104,5 @@
 # 
 if $INTPRI_CFGINT_VALID.nil?
-  $INTPRI_CFGINT_VALID = $TMIN_INTPRI.val.upto($TMAX_INTPRI.val).to_a
+  $INTPRI_CFGINT_VALID = $TMIN_INTPRI.upto($TMAX_INTPRI).to_a
 end
 
@@ -151,6 +150,6 @@
     if !$INTNO_FIX_NONKERNEL.index(params[:intno]).nil?
       if params[:intpri] >= $TMIN_INTPRI
-        error_ercd("E_OBJ", params, "intno `#{params[:intno]}'" \
-							" must have higher priority than TMIN_INTPRI")
+        error_ercd("E_OBJ", params, "%%intno must have higher priority " \
+											"than TMIN_INTPRI in %apiname")
       end
     end
@@ -162,6 +161,6 @@
     if !$INTNO_FIX_KERNEL.index(params[:intno]).nil?
       if params[:intpri] < $TMIN_INTPRI
-        error_ercd("E_OBJ", params, "intno `#{params[:intno]}'" \
-					" must have lower or equal priority to TMIN_INTPRI")
+        error_ercd("E_OBJ", params, "%%intno must have lower or equal " \
+									"priority to TMIN_INTPRI in %apiname")
       end
     end
@@ -180,5 +179,5 @@
   # inhatrãç¡å¹ã®å ´åï¼E_RSATRï¼ï¼»NGKI3052ï¼½
   #ï¼TARGET_INHATRä»¥å¤ã®ããããã»ããããã¦ããå ´åï¼
-  if (params[:inhatr] & ~$TARGET_INHATR) != 0
+  if (params[:inhatr] & ~($TARGET_INHATR)) != 0
     error_illegal_sym("E_RSATR", params, :inhatr, :inhno)
   end
@@ -189,6 +188,6 @@
     if !$INHNO_FIX_NONKERNEL.index(params[:inhno]).nil?
       if (params[:inhatr] & $TA_NONKERNEL) == 0
-        error_ercd("E_RSATR", params, "inhno `#{params[:inhno]}'" \
-									" must be non-kernel interrupt")
+        error_ercd("E_RSATR", params, "%%inhno must be " \
+								"non-kernel interrupt in %apiname")
       end
     end
@@ -200,6 +199,6 @@
     if !$INHNO_FIX_KERNEL.index(params[:inhno]).nil?
       if (params[:inhatr] & $TA_NONKERNEL) != 0
-        error_ercd("E_RSATR", params, "inhno `#{params[:inhno]}'" \
-									" must not be non-kernel interrupt")
+        error_ercd("E_RSATR", params, "%%inhno must not be " \
+								"non-kernel interrupt in %apiname")
       end
     end
@@ -211,6 +210,6 @@
     # inhnoã«å¯¾å¿ããintnoã«å¯¾ããCFG_INTããªãå ´åï¼E_OBJï¼ï¼»NGKI3062ï¼½
     if !$cfgData[:CFG_INT].has_key?(intnoVal)
-      error_ercd("E_OBJ", params, "intno `#{intnoVal}' corresponding to" \
-				" inhno `#{params[:inhno]}' is not configured with CFG_INT")
+      error_ercd("E_OBJ", params, "intno `#{intnoVal}' corresponding to " \
+					"%%inhno in %apiname is not configured with CFG_INT")
     else
       intnoParams = $cfgData[:CFG_INT][intnoVal]
@@ -221,7 +220,6 @@
         # ããå ´åï¼E_OBJï¼ï¼»NGKI3065ï¼½
         if intnoParams[:intpri] < $TMIN_INTPRI
-          error_ercd("E_OBJ", params, "intpri `#{intnoParams[:intpri]}'" \
-						" configured for inhno `#{params[:inhno]}' must" \
-						" be lower or equal to TMIN_INTPRI")
+          error_ercd("E_OBJ", params, "intpri `#{intnoParams[:intpri]}' " \
+				"configured for %%inhno must be lower or equal to TMIN_INTPRI")
         end
       else
@@ -231,7 +229,6 @@
         # å ´åï¼E_OBJï¼ï¼»NGKI3066ï¼½
         if intnoParams[:intpri] >= $TMIN_INTPRI
-          error_ercd("E_OBJ", params, "intpri `#{intnoParams[:intpri]}'" \
-						" configured for inhno `#{params[:inhno]}' must" \
-						" be higher than with TMIN_INTPRI")
+          error_ercd("E_OBJ", params, "intpri `#{intnoParams[:intpri]}' " \
+					"configured for %%inhno must be higher than TMIN_INTPRI")
         end
       end
@@ -246,5 +243,5 @@
   #	isratrãç¡å¹ã®å ´åï¼E_RSATRï¼ï¼»NGKI2998ï¼½
   #ï¼TARGET_ISRATRä»¥å¤ã®ããããã»ããããã¦ããå ´åï¼
-  if (params[:isratr] & ~$TARGET_ISRATR) != 0
+  if (params[:isratr] & ~($TARGET_ISRATR)) != 0
     error_illegal("E_RSATR", params, "isratr")
   end
@@ -267,5 +264,5 @@
   isrParamsList = []
   $cfgData[:CRE_ISR].sort.each do |key, params|
-    if params[:intno].val == intnoVal
+    if params[:intno] == intnoVal
       isrParamsList.push(params)
     end
@@ -279,14 +276,12 @@
     if $cfgData[:DEF_INH].has_key?(inhnoVal)
       inhnoParams = $cfgData[:DEF_INH][inhnoVal]
-      error_ercd("E_OBJ", isrParamsList[0], \
-					"intno `#{isrParamsList[0][:intno]}' in CRE_ISR" \
-					" is duplicated with inhno #{inhnoParams[:inhno]}")
+      error_ercd("E_OBJ", isrParamsList[0], "%%intno in %apiname " \
+					"is duplicated with inhno #{inhnoParams[:inhno]}")
     end
 
     # intnoã«å¯¾ããCFG_INTããªãå ´åï¼E_OBJï¼ï¼»NGKI3012ï¼½
     if !$cfgData[:CFG_INT].has_key?(intnoVal)
-      error_ercd("E_OBJ", isrParamsList[0], \
-						"intno `#{isrParamsList[0][:intno]}'" \
-						" is not configured with CFG_INT")
+      error_ercd("E_OBJ", isrParamsList[0], "%%intno in %apiname " \
+									"is not configured with CFG_INT")
     else
       intnoParams = $cfgData[:CFG_INT][intnoVal]
@@ -297,7 +292,6 @@
       if intnoParams[:intpri] < $TMIN_INTPRI
         error_ercd("E_OBJ", isrParamsList[0],
-						"intpri `#{intnoParams[:intpri]}' configured for" \
-						" intno `#{isrParamsList[0][:intno]}}' in higher" \
-						" than TMIN_INTPRI")
+						"intpri `#{intnoParams[:intpri]}' configured for " \
+						"%%intno with CFG_INT in higher than TMIN_INTPRI")
       end
     end
@@ -305,10 +299,9 @@
     # æ¬¡ã®DEF_INHã«ç¸å½ãããã¼ã¿ãçæ
     # DEF_INH(inhno, { TA_NULL, _kernel_inthdr_<intno> } );
-    params = {
-      :inhno => StrVal.new(inhnoVal.to_s, inhnoVal),
-      :inhatr => $TA_NULL,
-      :inthdr => StrVal.new("_kernel_inthdr_#{intnoVal}")
+    $cfgData[:DEF_INH][inhnoVal] = {
+      inhno: NumStr.new(inhnoVal),
+      inhatr: NumStr.new($TA_NULL, "TA_NULL"),
+      inthdr: "_kernel_inthdr_#{intnoVal}"
     }
-    $cfgData[:DEF_INH][inhnoVal] = params
 
     # å²è¾¼ã¿ãµã¼ãã¹ã«ã¼ãã³ç¨ã®å²è¾¼ã¿ãã³ãã©
@@ -340,12 +333,11 @@
 å ±ã®çæ
 #
-if $OMIT_INITIALIZE_INTERRUPT.nil? || !$USE_INHINIB_TABLE.nil?
+if !$OMIT_INITIALIZE_INTERRUPT || $USE_INHINIB_TABLE
   #
   #  å®ç¾©ããå²è¾¼ã¿ãã³ãã©ã®æ°
   #
-  $kernelCfgC.append(<<EOS)
+  $kernelCfgC.add(<<EOS)
 #define TNUM_DEF_INHNO	#{$cfgData[:DEF_INH].size}
 const uint_t _kernel_tnum_def_inhno = TNUM_DEF_INHNO;
-
 EOS
 
@@ -388,12 +380,11 @@
 å ±ã®çæ
 #
-if $OMIT_INITIALIZE_INTERRUPT.nil? || !$USE_INTINIB_TABLE.nil?
+if !$OMIT_INITIALIZE_INTERRUPT || $USE_INTINIB_TABLE
   #
   #  è¨­å®ããå²è¾¼ã¿è¦æ±ã©ã¤ã³ã®æ°
   #
-  $kernelCfgC.append(<<EOS)
+  $kernelCfgC.add(<<EOS)
 #define TNUM_CFG_INTNO	#{$cfgData[:CFG_INT].size}
 const uint_t _kernel_tnum_cfg_intno = TNUM_CFG_INTNO;
-
 EOS
 
Index: asp3_wo_tecs/trunk/kernel/kernel.trb
===================================================================
--- asp3_wo_tecs/trunk/kernel/kernel.trb	(revision 305)
+++ asp3_wo_tecs/trunk/kernel/kernel.trb	(revision 306)
@@ -45,5 +45,5 @@
 #       å
 è²¬ãããã¨ï¼
-#
+# 
 #   æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
 ã
@@ -52,7 +52,7 @@
 #   ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ã
 #   ã®è²¬ä»»ãè² ããªãï¼
-#
-#   $Id: kernel.trb 588 2016-02-05 12:54:58Z ertl-hiro $
-#
+# 
+#   $Id: kernel.trb 670 2016-03-03 15:08:11Z ertl-hiro $
+# 
 
 #
@@ -60,7 +60,7 @@
 #
 
-# 
+#
 #  ã¿ã¤ã ã¹ã¿ã³ããã¡ã¤ã«ã®æå®
-# 
+#
 $timeStampFileName = "kernel_cfg.timestamp"
 
@@ -70,9 +70,8 @@
 #
 $kernelCfgH = GenFile.new("kernel_cfg.h")
-$kernelCfgH.append(<<EOS)
+$kernelCfgH.add(<<EOS)
 /* kernel_cfg.h */
 #ifndef TOPPERS_KERNEL_CFG_H
 #define TOPPERS_KERNEL_CFG_H
-
 EOS
 
@@ -82,5 +81,5 @@
 #
 $kernelCfgC = GenFile.new("kernel_cfg.c")
-$kernelCfgC.append(<<EOS)
+$kernelCfgC.add(<<EOS)
 /* kernel_cfg.c */
 #include "kernel/kernel_int.h"
@@ -90,10 +89,9 @@
 #error The kernel does not match this configuration file.
 #endif
-
-EOS
-
-# 
+EOS
+
+#
 #  ã¤ã³ã¯ã«ã¼ããã£ã¬ã¯ãã£ãï¼#includeï¼
-# 
+#
 $kernelCfgC.comment_header("Include Directives")
 $includeFiles.each do |file|
@@ -142,5 +140,5 @@
 
     # ãªãã¸ã§ã¯ãã®IDçªå·ãä¿æããå¤æ°
-    if !$USE_EXTERNAL_ID.nil?
+    if $USE_EXTERNAL_ID
       $cfgData[@api].sort.each do |key, params|
         $kernelCfgC.add("const ID #{params[@objid]}_id" \
@@ -224,11 +222,11 @@
 								|| (nfymode2 == $TENFY_SETFLG && epar2.nil?)
     # ãã©ã¡ã¼ã¿ãè¶³ããªãå ´å
-    error_api(params, "too few parameters for nfymode `#{nfymode}'" \
-							" in #{params[:apiname]} of #{params[objid]}")
+    error_api(params, "too few parameters for nfymode `#{nfymode}' " \
+											"in %apiname of %#{objid}")
   elsif (nfymode2 == 0 && !epar1.nil?) \
 					|| (nfymode2 != $TENFY_SETFLG && !epar2.nil?)
     # ãã©ã¡ã¼ã¿ãå¤ãããå ´å
-    error_api(params, "too many parameters for nfymode `#{nfymode}'" \
-							" in #{params[:apiname]} of #{params[objid]}")
+    error_api(params, "too many parameters for nfymode `#{nfymode}' " \
+											"in %apiname of %#{objid}")
   elsif nfymode == $TNFY_HANDLER
     # ã¿ã¤ã ã¤ãã³ããã³ãã©ã®å¼åºã
@@ -354,10 +352,10 @@
 IncludeTrb("kernel/exception.trb")
 
-# 
+#
 #  éã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ã®ã¹ã¿ãã¯é å
-# 
+#
 $kernelCfgC.comment_header("Stack Area for Non-task Context")
 
-if $cfgData[:DEF_ICS].size() == 0
+if $cfgData[:DEF_ICS].size == 0
   # DEF_ICSããªãå ´åã®ããã©ã«ãå¤ã®è¨­å®
   if $DEFAULT_ISTK.nil?
@@ -371,5 +369,5 @@
 else
   # éçAPIãDEF_ICSããè¤æ°ããï¼E_OBJï¼ï¼»NGKI3216ï¼½
-  if $cfgData[:DEF_ICS].size() > 1
+  if $cfgData[:DEF_ICS].size > 1
     error("E_OBJ: too many DEF_ICS")
   end
@@ -378,13 +376,16 @@
   params = $cfgData[:DEF_ICS][1]
 
+  # ãã©ã¡ã¼ã¿ãçç¥ãããæã®ããã©ã«ãå¤ã®è¨­å®
+  params[:istk] ||= "NULL"
+
   # istkszãã¿ã¼ã²ããå®ç¾©ã®æå°å¤ï¼TARGET_MIN_ISTKSZï¼æªå®ç¾©ã®å ´åã¯1ï¼
   # ãããå°ããå ´åï¼E_PARï¼ï¼»NGKI3254ï¼½
-  if params[:istksz] <= $TARGET_MIN_ISTKSZ
+  if params[:istksz] < $TARGET_MIN_ISTKSZ
     error_wrong("E_PAR", params, :istksz, "too small")
   end
 
-  if (params[:istk] == "NULL")
+  if params[:istk] == "NULL"
     # ã¹ã¿ãã¯é åã®èªåå²ä»ã
-	istksz = AllocStack("_kernel_istack", params[:istksz])
+    istksz = AllocStack("_kernel_istack", params[:istksz])
     istk = "_kernel_istack"
   else
@@ -399,5 +400,5 @@
 end
 
-$kernelCfgC.append(<<EOS)
+$kernelCfgC.add(<<EOS)
 const size_t _kernel_istksz = #{istksz};
 STK_T *const _kernel_istk = #{istk};
@@ -406,19 +407,17 @@
 STK_T *const _kernel_istkpt = TOPPERS_ISTKPT(#{istk}, #{istksz});
 #endif /* TOPPERS_ISTKPT */
-
-EOS
-
-# 
+EOS
+
+#
 #  ã¿ã¤ã ã¤ãã³ãç®¡ç
-# 
+#
 $kernelCfgC.comment_header("Time Event Management")
-$kernelCfgC.append(<<EOS)
+$kernelCfgC.add(<<EOS)
 TMEVTN   _kernel_tmevt_heap[1 + TNUM_TSKID + TNUM_CYCID + TNUM_ALMID];
-
-EOS
-
-# 
+EOS
+
+#
 #  åã¢ã¸ã¥ã¼ã«ã®åæåé¢æ°
-# 
+#
 $kernelCfgC.comment_header("Module Initialization Function")
 $kernelCfgC.append(<<EOS)
@@ -428,12 +427,11 @@
 EOS
 $initializeFunctions.each do |func|
-	$kernelCfgC.add("\t#{func}")
+  $kernelCfgC.add("\t#{func}")
 end
 $kernelCfgC.add2("}")
 
-# 
+#
 #  åæåã«ã¼ãã³æ©è½
-# 
-# 
+#
 $kernelCfgC.comment_header("Initialization Routine")
 
@@ -442,5 +440,5 @@
   # iniatrãç¡å¹ã®å ´åï¼E_RSATRï¼ï¼»NGKI3241ï¼½
   #ï¼TA_NULLã§ãªãå ´åï¼
-  if (params[:iniatr] != 0)
+  if (params[:iniatr] != $TA_NULL)
     error_illegal_sym("E_RSATR", params, :iniatr, :inirtn)
   end
@@ -459,7 +457,7 @@
 $kernelCfgC.add2("}")
 
-# 
+#
 #  çµäºå¦çã«ã¼ãã³æ©è½
-# 
+#
 $kernelCfgC.comment_header("Termination Routine")
 
@@ -468,5 +466,5 @@
   # teratrãç¡å¹ã®å ´åï¼E_RSATRï¼ï¼»NGKI3248ï¼½
   #ï¼TA_NULLã§ãªãå ´åï¼
-  if (params[:teratr] != 0)
+  if (params[:teratr] != $TA_NULL)
     error_illegal_sym("E_RSATR", params, :teratr, :terrtn)
   end
Index: asp3_wo_tecs/trunk/kernel/kernel_api.def
===================================================================
--- asp3_wo_tecs/trunk/kernel/kernel_api.def	(revision 305)
+++ asp3_wo_tecs/trunk/kernel/kernel_api.def	(revision 306)
@@ -1,9 +1,9 @@
-CRE_TSK #tskid* { .tskatr &exinf &task +itskpri .stksz &stk }
+CRE_TSK #tskid* { .tskatr &exinf &task +itskpri .stksz &stk? }
 CRE_SEM #semid* { .sematr .isemcnt .maxsem }
 CRE_FLG #flgid* { .flgatr .iflgptn }
-CRE_DTQ #dtqid* { .dtqatr .dtqcnt &dtqmb }
-CRE_PDQ #pdqid* { .pdqatr .pdqcnt +maxdpri &pdqmb }
+CRE_DTQ #dtqid* { .dtqatr .dtqcnt &dtqmb? }
+CRE_PDQ #pdqid* { .pdqatr .pdqcnt +maxdpri &pdqmb? }
 CRE_MTX #mtxid* { .mtxatr +ceilpri? }
-CRE_MPF #mpfid* { .mpfatr .blkcnt .blksz &mpf &mpfmb }
+CRE_MPF #mpfid* { .mpfatr .blkcnt .blksz &mpf? &mpfmb? }
 CRE_CYC #cycid* { .cycatr { .nfymode &par1 &par2? &par3? &par4? } .cyctim .cycphs }
 CRE_ALM #almid* { .almatr { .nfymode &par1 &par2? &par3? &par4? } }
@@ -12,5 +12,5 @@
 DEF_INH .inhno* { .inhatr &inthdr }
 DEF_EXC .excno* { .excatr &exchdr }
-DEF_ICS { .istksz &istk }
+DEF_ICS { .istksz &istk? }
 ATT_INI { .iniatr &exinf &inirtn }
 ATT_TER { .teratr &exinf &terrtn }
